using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using TB.Web.UI.WebControls;
using System.Collections.Generic;

namespace TB.Web.UI.TreeGridDemo
{
    public class Builder
    {
        static Builder()
        {
            nodeDataDic = new Dictionary<string, Foo>();
            nodeDataDic.Add("value_1",      new Foo("11", "12", "13", "14", "15", "16"));
            nodeDataDic.Add("value_11",     new Foo("1a1", "1a2", "1a3", "1a4", "1a5", "1a6"));
            nodeDataDic.Add("value_111",    new Foo("1a1", "1a2", "1a3", "1a4", "1a5", "1a6"));
            nodeDataDic.Add("value_112",    new Foo("1a1", "1a2", "1a3", "1a4", "1a5", "1a6"));
            nodeDataDic.Add("value_113",    new Foo("1a1", "1a2", "1a3", "1a4", "1a5", "1a6"));
            nodeDataDic.Add("value_114",    new Foo("1a1", "1a2", "1a3", "1a4", "1a5", "1a6"));
            nodeDataDic.Add("value_115",    new Foo("1a1", "1a2", "1a3", "1a4", "1a5", "1a6"));
            nodeDataDic.Add("value_116",    new Foo("1a1", "1a2", "1a3", "1a4", "1a5", "1a6"));
            nodeDataDic.Add("value_12",     new Foo("1b1", "1b2", "1b3", "1b4", "1b5", "1b6"));
            nodeDataDic.Add("value_121",    new Foo("1b1", "1b2", "1b3", "1b4", "1b5", "1b6"));
            nodeDataDic.Add("value_122",    new Foo("1b1", "1b2", "1b3", "1b4", "1b5", "1b6"));
            nodeDataDic.Add("value_2",      new Foo("21", "22", "23", "24", "25", "26"));
            nodeDataDic.Add("value_21",     new Foo("2a1", "2a2", "2a3", "2a4", "2a5", "2a6"));
            nodeDataDic.Add("value_22",     new Foo("2b1", "2b2", "2b3", "2b4", "2b5", "2b6"));
            nodeDataDic.Add("value_23",     new Foo("2c1", "2c2", "2c3", "2c4", "2c5", "2c6"));
            nodeDataDic.Add("value_24",     new Foo("2d1", "2d2", "2d3", "2d4", "2d5", "2d6"));
            nodeDataDic.Add("value_25",     new Foo("2e1", "2e2", "2e3", "2e4", "2e5", "2e6"));
            nodeDataDic.Add("value_26",     new Foo("2f1", "2f2", "2f3", "2f4", "2f5", "2f6"));
            nodeDataDic.Add("value_261",    new Foo("2f1", "2f2", "2f3", "2f4", "2f5", "2f6"));
            nodeDataDic.Add("value_262",    new Foo("2f1", "2f2", "2f3", "2f4", "2f5", "2f6"));
            nodeDataDic.Add("value_263",    new Foo("2f1", "2f2", "2f3", "2f4", "2f5", "2f6"));
            nodeDataDic.Add("value_3",      new Foo("31", "32", "33", "34", "35", "36"));
            nodeDataDic.Add("value_4",      new Foo("41", "42", "43", "44", "45", "46"));
        }

        public static void InitTreeGridManual(TreeGrid tg)
        {
            TreeGridNode node = new TreeGridNode("value_1");
            tg.Nodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.ToolTip = "tooltip";

            node = new TreeGridNode("value_11");
            tg.Nodes[0].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);

            node = new TreeGridNode("value_111");
            tg.Nodes[0].ChildNodes[0].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;
            node = new TreeGridNode("value_112");
            tg.Nodes[0].ChildNodes[0].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;
            node = new TreeGridNode("value_113");
            tg.Nodes[0].ChildNodes[0].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;
            node = new TreeGridNode("value_114");
            tg.Nodes[0].ChildNodes[0].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;
            node = new TreeGridNode("value_115");
            tg.Nodes[0].ChildNodes[0].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;
            node = new TreeGridNode("value_116");
            tg.Nodes[0].ChildNodes[0].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;

            node = new TreeGridNode("value_12");
            tg.Nodes[0].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);

            node = new TreeGridNode("value_121");
            tg.Nodes[0].ChildNodes[1].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;
            node = new TreeGridNode("value_122");
            tg.Nodes[0].ChildNodes[1].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;



            node = new TreeGridNode("value_2");
            tg.Nodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.ToolTip = "tooltip";

            node = new TreeGridNode("value_21");
            tg.Nodes[1].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;

            node = new TreeGridNode("value_22");
            tg.Nodes[1].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;

            node = new TreeGridNode("value_23");
            tg.Nodes[1].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;

            node = new TreeGridNode("value_24");
            tg.Nodes[1].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;

            node = new TreeGridNode("value_25");
            tg.Nodes[1].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;

            node = new TreeGridNode("value_26");
            tg.Nodes[1].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);

            node = new TreeGridNode("value_261");
            tg.Nodes[1].ChildNodes[5].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;
            node = new TreeGridNode("value_262");
            tg.Nodes[1].ChildNodes[5].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;
            node = new TreeGridNode("value_263");
            tg.Nodes[1].ChildNodes[5].ChildNodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.PopulateOnDemand = true;


            node = new TreeGridNode("value_3");
            tg.Nodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.ToolTip = "tooltip";
            node.PopulateOnDemand = true;


            node = new TreeGridNode("value_4");
            tg.Nodes.Add(node);
            node.DataItem = GetNodeData(node.Value);
            node.ToolTip = "tooltip";
            node.PopulateOnDemand = true;


            tg.ManualDataBind();
        }

        private static Dictionary<string, Foo> nodeDataDic = null;

        public static Foo GetNodeData(string nodeValue)
        { 
            if (nodeDataDic.ContainsKey(nodeValue))
                return nodeDataDic[nodeValue];
            else
                return new Foo("new", "n2", "n3", "n4", "n5", "n6");
        }
    }
}
